import { Operation, ApolloLink, FetchResult, Observable } from 'apollo-link-core';
export declare function mockSingleLink(...mockedResponses: MockedResponse[]): ApolloLink;
export declare function mockObservableLink(mockedSubscription: MockedSubscription): MockSubscriptionLink;
export interface MockedResponse {
    request: Operation;
    result?: FetchResult;
    error?: Error;
    delay?: number;
}
export interface MockedSubscriptionResult {
    result?: FetchResult;
    error?: Error;
    delay?: number;
}
export interface MockedSubscription {
    request: Operation;
}
export declare class MockLink extends ApolloLink {
    private mockedResponsesByKey;
    constructor(mockedResponses: MockedResponse[]);
    addMockedResponse(mockedResponse: MockedResponse): void;
    request(operation: Operation): Observable<FetchResult<Record<string, any>, Record<string, any>>>;
}
export declare class MockSubscriptionLink extends ApolloLink {
    mockedSubscription: MockedSubscription;
    private observer;
    constructor(mockedSubscription: MockedSubscription);
    request(): Observable<FetchResult<Record<string, any>, Record<string, any>>>;
    simulateResult(result: MockedSubscriptionResult): void;
}
